describe('Operator home page', function () {
  it('Creates the simplest possible survey', function () {
    cy.server()
      .route('PUT', '/**')
      .as('uploadProductPhoto')

    cy.loginAsOperator()
      .visit('/operator/surveys')
      .getByTestId('create-survey-button')
      .click()
      .get('input[name="name"]')
      .type(`E2E test ${Date.now()}`)
      .getByTestId('authorization-type-select')
      .click()
      .getByTestId('authorizationType-select-option-0')
      .click()
      .get('.ant-tabs-nav [role="tab"]:nth-child(2)')
      .click()
      .getByTestId('new-product-button')
      .click()
      .get('input[name="name"]')
      .type('Test Product')
      .get('input[name="brand"]')
      .type('E2E brand')
      .uploadFile({
        selector: '.ant-upload input[type="file"]',
        fixturePath: 'pictures/leaf.png',
        mimeType: 'image/png',
        fileName: 'leaf.png'
      })
      .wait('@uploadProductPhoto')
      .get('.ant-tabs-nav [role="tab"]:nth-child(3)')
      .click()
      .getByTestId('new-step-button')
      .click()
      .getByTestId('question-type-select')
      .click()
      .getByTestId('questionType-select-option-0')
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]:nth-child(1)')
      .type('Did you like the product?')
      .get('input[name="secondaryPrompt"]')
      .type('Product additional information')

      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-1').last()
      .click()

      .getByTestId('save-draft-survey-button')
      .click() 
      .wait(2000)
      .get('input[name="chartTitle"]')
      .type('Pie chart')
      .get('input[name="chartTopic"]')
      .type('flavor')
      .getByTestId('type-of-chart-select')
      .click()
      .getByTestId('typeOfChart-select-option-0')
      .click()
      .getByTestId('choose-multiple-question-text')
      .type('How interested are you in purchasing adult nutritional shakes that are low calorie')
      .get('input[name="0-label"]')
      .type('Pie')
      .get('input[name="0-value"]')
      .type('pi')
      .get('input[name="1-label"]')
      .type('Fusion')
      .get('input[name="1-value"]')
      .type('fusion')
      //Choose one question
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-2').last()
      .click()

      .get('.question-creation-card input[name="chartTitle"]').last().click()
      .type('Consumed Brands')
      .get('.question-creation-card input[name="chartTopic"]').last().click()
      .type('chocalate flavor')
      .get('.question-creation-card').last()
      .queryAllByTestId('type-of-chart-select').last()
      .click()
      .queryAllByTestId('typeOfChart-select-option-1').last()
      .click()
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Which of the following adult nutritional shakes have you consumed')
      .get('.question-creation-card').last()
      .get('input[name="0-label"]').last()
      .type('columns')
      .get('input[name="0-value"]').last()
      .type('columns')
      .get('input[name="1-label"]').last()
      .type('Stack label')
      .get('input[name="1-value"]').last()
      .type('stacklabel')
      //Choose question end 

      //Choose product question
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-3').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Please enter a product name')
      .get('input[name="secondaryPrompt"]').last()
      .type('Product information here')
      //End Choose product question

      //Dropdown question
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-4').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="chartTitle"]').last().click()
      .type('Consumed Brands')
      .get('.question-creation-card input[name="chartTopic"]').last().click()
      .type('chocalate flavor')
      .get('.question-creation-card').last()
      .queryAllByTestId('type-of-chart-select').last()
      .click()
      .queryAllByTestId('typeOfChart-select-option-1').last()
      .click()
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Which of the following adult nutritional shakes have you consumed')
      .get('.question-creation-card input[name="secondaryPrompt"]').last().click()
      .type('Additional information for dropdown')
      .get('.question-creation-card').last()
      .get('input[name="0-label"]').last()
      .type('column two')
      .get('input[name="0-value"]').last()
      .type('columntwo')
      .get('input[name="1-label"]').last()
      .type('Stack two')
      .get('input[name="1-value"]').last()
      .type('stacktwo')
      //End of Dropdown question

      //Email question
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-5').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Enter your email')
      //End of Email question

      //Info question
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-6').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Enter your information here')
      .get('.e2e-text-editor').find('[contenteditable]').type('some text')
      //End of Info question

      //Open Answer question
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-7').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Which of the flavor do ypu like more ?')
      .get('.question-creation-card input[name="secondaryPrompt"]').last().click()
      .type('chocalate type')
      //End of Open Answer question
      
      //Paired Questions
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-8').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card').last()
      .get('.question-creation-card input[name="chartTitle"]').last().click()
      .type('Flavor type')
      .get('.question-creation-card input[name="chartTopic"]').last().click()
      .type('spider')
      .get('.question-creation-card').last()
      .queryAllByTestId('type-of-chart-select').last()
      .click()
      .queryAllByTestId('typeOfChart-select-option-0').last()
      .click()
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('In the following question there will be multiple pairs of FLAVORS')
      .get('.question-creation-card input[name="secondaryPrompt"]').last().click()
      .type('You have answered 10 out of 15 times')
      .get('[type="checkbox"]').check({ force: true })
      .get('.question-creation-card input[name="profilePrompt"]').last().click()
      .type('Please provide profile step.')
      .get('.question-creation-card').last()
      .getByTestId('add-value-button')
      .click()
      .getByTestId('add-value-text')
      .type('sweet')
      .getByTestId('add-value-text').click()
      .get('.question-creation-card').last()
      .getByTestId('add-value-text').blur()
      .getByTestId('add-value-button')
      .click()
      .getByTestId('add-value-text')
      .click()
      .type('creamy')
      .getByTestId('paired-minimum-pairs')
      .click()
      //.type('1')
      //End of Paired Questions

      //Select And Justify Questions
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-9').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('How much did you pay for the entire package of bottles?')
      .get('.question-creation-card input[name="secondaryPrompt"]').last().click()
      .type('These questions relate to simply and justfy')
      .get('.question-creation-card').last()
      .get('input[name="0-label"]').last()
      .type('column three')
      .get('input[name="0-value"]').last()
      .type('columnthree')
      .get('input[name="1-label"]').last()
      .type('Stack three')
      .get('input[name="1-value"]').last()
      .type('stackthree')
      //End of Select And Justify Questions

      //Slider Questions
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-10').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="chartTitle"]').last().click()
      .type('Consumed Brands')
      .get('.question-creation-card input[name="chartTopic"]').last().click()
      .type('flavor')
      .get('.question-creation-card').last()
      .queryAllByTestId('type-of-chart-select').last()
      .click()
      .queryAllByTestId('typeOfChart-select-option-0').last()
      .click()
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Which of the following adult nutritional shakes have you consumed')
      .get('.question-creation-card input[name="secondaryPrompt"]').last().click()
      .type('Additional information for dropdown')

      .get('.question-creation-card input[name="min"]').last().click()
      .type('3')
      .get('.question-creation-card input[name="step"]').last().click()
      .type('1')
      .get('.question-creation-card input[name="max"]').last().click()
      .type('5')
      .get('.question-creation-card input[name="0-label"]').last().click()
      .type('label here')
      //End of Slider Questions

      //Upload Picture Questions
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-11').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Upload picture here.')
      //End of Upload Picture Questions

      //Upload Picture Questions
      .getByTestId('new-step-button')
      .click()
      .get('.question-creation-card').last()
      .queryAllByTestId('question-type-select').last()
      .click()
      .queryAllByTestId('questionType-select-option-12').last()
      .click()
      .getByTestId('save-draft-survey-button')
      .click()
      .wait(2000)
      .get('.question-creation-card input[name="chartTitle"]').last().click()
      .type('Consumed Brands')
      .get('.question-creation-card input[name="chartTopic"]').last().click()
      .type('flavor')
      .get('.question-creation-card').last()
      .queryAllByTestId('type-of-chart-select').last()
      .click()
      .queryAllByTestId('typeOfChart-select-option-0').last()
      .click()
      .get('.question-creation-card input[name="prompt"]').last().click()
      .type('Which of the following adult nutritional shakes have you consumed')
      .get('.question-creation-card input[name="secondaryPrompt"]').last().click()
      .type('Additional information for dropdown')
      .get('.question-creation-card input[name="min"]').last().click()
      .type(3)
      .get('.question-creation-card input[name="max"]').last().click()
      .type(5)
      //End of Upload Picture Questions

      .getByTestId('publish-survey-button')
      .click()
      //.assertRoute('/operator/surveys', { timeout: 30000 }) 
  })
})
